SystemOrganization addCategory: #'Sight-Tracing'!
SystemOrganization addCategory: #'Sight-Tracing-Weaving'!
SystemOrganization addCategory: #'Sight-Tracing-Wrapping'!

MwMethodWrapper subclass: #STracingWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing-Wrapping'!

!STracingWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 13:35:31.762'!
initialize	
	" self initialize "
	super initialize.! !

!STracingWrapper methodsFor: 'as yet unclassified' stamp: 'bs 7/22/2010 09:01:16.051'!
uninstrumenteMethod
	^ self unwrappedMethod! !

!STracingWrapper methodsFor: 'evaluating' stamp: 'bs 7/5/2010 11:15:05.369'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	self methodExtension beforeMethodWithReceiver: anObject. 
	^ self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects! !

MwMethodWrapper subclass: #SWithTracingWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing-Wrapping'!

!SWithTracingWrapper methodsFor: 'evaluating' stamp: 'bs 8/10/2010 15:27:10.276'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| codeSight |
	codeSight := self codeSight.
	^ [
		codeSight csTestRunner activateTracing. 
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [ codeSight csTestRunner deactivateTracing. ]! !

Object subclass: #SMethodExtension
	instanceVariableNames: 'clientMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing'!

!SMethodExtension methodsFor: 'evaluating' stamp: 'bs 7/5/2010 08:33:07.472'!
beforeMethod! !

!SMethodExtension methodsFor: 'evaluating' stamp: 'bs 7/5/2010 08:32:59.992'!
beforeMethodWithReceiver: anObject! !

!SMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:02'!
clientMethod
	^ clientMethod! !

!SMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:02'!
clientMethod: anObject
	clientMethod := anObject! !

!SMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:03'!
unwrappedMethod
	^ self clientMethod unwrappedMethod! !

STbTestCase subclass: #STracingTestCase
	instanceVariableNames: 'instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing'!

STracingTestCase subclass: #SClassEventTests
	instanceVariableNames: 'unwrappedMethods classModified metaClassModified classItem oldClassItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing'!

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 8/9/2010 17:39:43.01'!
handleClassEvent: aClassEvent
	classItem := aClassEvent item.
	oldClassItem := aClassEvent oldItem.! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:26:07.811'!
setUp
	super setUp.
	self undoInTearDownDo: [
		self tracePackage: self tbPackage ].! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/11/2010 10:18'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 22:09:35.845'!
testClassModification
	self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	self addInstVar: 'f' to: STbPerson.
	self deny: classItem = oldClassItem.
	self deny: classItem class = oldClassItem class.! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 22:25:36.359'!
testMetaClassModification
	self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	self addClassVar: 'Foo' to: STbPerson.
	self deny: classItem = oldClassItem.
	self deny: classItem class = oldClassItem class.! !

!SClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 22:27:27.112'!
testMethodDictAccessOfModifiedClass
	self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	self addInstVar: 'f' to: STbPerson.
	self assert: (oldClassItem methodDict values noneSatisfy: [ :ea | ea == nil ]).
	self deny: classItem methodDict = oldClassItem methodDict.
	self deny: classItem class methodDict = oldClassItem class methodDict.! !

!STracingTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/5/2010 10:33:18.828'!
createInstrumentor
	^ SInstrumentor wrapping! !

!STracingTestCase methodsFor: 'event processing' stamp: 'bs 8/17/2010 19:29:57.377'!
handleEvent: aSystemEvent
	| aSightEvent |
	(self isClassManaged: aSystemEvent itemClass)
		ifTrue: [
			aSightEvent := SSystemEventAnalyzer new analyze: aSystemEvent.
			self instrumentor preprocess: aSightEvent.
			self instrumentor postprocess: aSightEvent]! !

!STracingTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 19:40:49.069'!
instrumentor
	^ instrumentor ifNil: [instrumentor := self createInstrumentor]! !

!STracingTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 19:28:19.436'!
isClassManaged: aClass
	^ self instrumentor instrumentedPackages includes: (self packageOfClass: aClass)! !

!STracingTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/9/2010 17:33:45.847'!
packageOfClass: aClass
	^ self instrumentor packageOfClass: aClass! !

!STracingTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2010 17:43:31.178'!
removeMethod: aMethod
	super removeMethod: aMethod uninstrumentedMethod! !

!STracingTestCase methodsFor: 'running' stamp: 'bs 8/10/2010 09:45:33.794'!
setUp
	super setUp.
	{ #class. #method. } do: [ :itemKind |
		self systemNotifier 
			notify: self 
			ofSystemChangesOfItem: itemKind  
			using: #handleEvent: ].! !

!STracingTestCase methodsFor: 'accessing' stamp: 'bs 7/4/2010 20:05:33.337'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!STracingTestCase methodsFor: 'running' stamp: 'bs 8/17/2010 22:35:42.387'!
tearDown
	self systemNotifier noMoreNotificationsFor: self.
	self removeAddedInstAndClassVars.
	self instrumentor cleanUp.
	self tbMethods do: [ :ea | ea resetMethodExtension ].
	super tearDown.! !

!STracingTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 19:56:56.714'!
testReinstrumentingTestMethods
	self tracePackage: self tbPackage.
	self assert: self exampleTestMethod hasMethodExtension.
	self compileExampleTestMethod.
	self assert: self exampleTestMethod hasMethodExtension! !

!STracingTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/4/2010 19:52:50.99'!
tracePackage: aPackageInfo
	(self instrumentor instrumentedPackages includes: aPackageInfo)
		ifFalse: [ self instrumentor instrumentPackage: aPackageInfo ]! !

STracingTestCase subclass: #SWeavingInstrumentorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing-Weaving'!

!SWeavingInstrumentorTests methodsFor: 'running' stamp: 'bs 7/5/2010 10:50:52.526'!
createInstrumentor
	^ SInstrumentor weaving! !

!SWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 07:46:23.444'!
methodsOfPackage: aPackageInfo
	^ (aPackageInfo classes flatCollect: [ :c | {c. c class} ]) flatCollect: [ :c | c methodDict values ]! !

!SWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 07:55:04.122'!
nonTestMethodsOfPackage: aPackageInfo
	^ (aPackageInfo classes flatCollect: [ :c | {c. c class} ]) 
			flatCollect: [ :c | c methodDict values reject: [ :m | m isTestMethod ] ]! !

!SWeavingInstrumentorTests methodsFor: 'running' stamp: 'bs 8/9/2010 22:12:43.02'!
tearDown
	self tbMethods
		select: [:ea | ea isInstrumentedMethod ]
		thenDo: [:ea | ea uninstrumentedMethod installSilently].
	super tearDown.! !

!SWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:26:07.906'!
testCompiledMethodAccess
	
	self tracePackage: self tbPackage.
	self should: [ (STbPerson >> #firstname) isInstrumentedMethod ].! !

!SWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 18:22:22.432'!
testExtensionCleanUpAfterMethodRemoval
	| orginalIndexSize getCurrentIndexSize aPackage methods nonTestMethods |
	getCurrentIndexSize := [ SWeavingInstrumentor orderedExtensions size ].
	orginalIndexSize := getCurrentIndexSize value.
	
	aPackage := self tbPackage.
	self instrumentor instrumentPackage: aPackage.
	
	nonTestMethods := self nonTestMethodsOfPackage: aPackage.
	self should: [ nonTestMethods allSatisfy: [ :m | m isInstrumentedMethod ] ].
	self should: [ nonTestMethods allSatisfy: [ :m | 
			m methodExtension isKindOf: SMethodExtension ] ].
	self should: [ nonTestMethods allSatisfy: [ :m | 
			m uninstrumentedMethod methodExtension isKindOf: SMethodExtension ] ].
	self should: [ getCurrentIndexSize value = (orginalIndexSize + nonTestMethods size) ].
	
	self instrumentor uninstrumentPackage: aPackage.
	methods := self methodsOfPackage: aPackage.
	self should: [ methods allSatisfy: [ :m | m isInstrumentedMethod not ] ].
	self should: [ getCurrentIndexSize value = orginalIndexSize  ].! !

!SWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 8/9/2010 22:38:06.816'!
testReinstrumentAfterChangeOfInstrumentedMethod
	
	self tracePackage: self tbPackage.
	self should: [self exampleMethod isInstrumentedMethod ].
	self compileExampleMethod.
	self should: [self exampleMethod isInstrumentedMethod ].! !

STracingTestCase subclass: #SWrapperExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing'!

!SWrapperExtensionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:16.08'!
testConflictDetection
	| wrapperOne wrapperTwo aClass aSelector |
	aClass := STbPerson.
	aSelector := #firstname:.
	
	self undoInTearDownDo: [
		wrapperOne := self createWrapper: MwCalledMethodWrapper on: aSelector inClass: aClass.
		wrapperTwo := self createWrapper: MwCountMethodWrapper on: aSelector inClass: aClass.
		].
	
	wrapperOne installClosestToMethod.
	self should: [ wrapperTwo installClosestToMethod ] raise: AssertionFailure.
	
	wrapperTwo uninstall.
	wrapperOne uninstall.! !

!SWrapperExtensionTests methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:16.071'!
testInstallClosestToMethod
	| current wrapperOne wrapperTwo aClass aSelector |
	aClass := STbPerson.
	aSelector := #firstname:.
	current := aClass compiledMethodAt: aSelector.
	
	self undoInTearDownDo: [
		wrapperOne := self createWrapper: MwCalledMethodWrapper on: aSelector inClass: aClass.
		wrapperTwo := self createWrapper: MwCountMethodWrapper on: aSelector inClass: aClass.
		].
	
	wrapperOne install.
	wrapperTwo installClosestToMethod.
	
	self deny: [ wrapperTwo clientMethod isMwMethodWrapper ].
	
	current isMwMethodWrapper
		ifTrue: [ 
			self assert: [ current clientMethod == wrapperTwo ].
			self assert: [ wrapperOne clientMethod == current ] ]
		ifFalse: [
			self assert: [ wrapperTwo clientMethod == current ].
			self assert: [ wrapperOne clientMethod == wrapperTwo ] ].
	
	wrapperTwo uninstall.
	wrapperOne uninstall.! !

STracingTestCase subclass: #SWrappingInstrumentorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing-Wrapping'!

!SWrappingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/5/2010 10:32:57.955'!
createInstrumentor
	^ SInstrumentor wrapping! !

!SWrappingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 13:29:43.009'!
createWrappingTestClass
	| aClass |
	aClass := Object subclass: #SFooBarWrapping
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: self tbCategory.
	
	self createdClasses add: aClass.
	^ aClass! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 8/9/2010 22:56:57.162'!
testDynamicRegistrationAndWrappingOfClassesAndMethods
	| aClass selector |

	selector := self exampleMethod selector.
	self tracePackage: self tbPackage.
	aClass := self createWrappingTestClass.
	aClass compile: (self exampleMethodSource).
	self assert: [(aClass >> selector) isMwMethodWrapper]. 
	aClass removeSelector: selector.
	aClass compile: (STbPerson sourceCodeAt: selector).
	aClass removeFromSystem. 
	self assert: (aClass methodDict values noneSatisfy: [:ea | ea isMwMethodWrapper]).! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 7/1/2010 09:01:48.275'!
testForIsInstalled
	self should: [MwMethodWrapper canUnderstand: #isInstalled]! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 8/10/2010 09:20:24.749'!
testReregistrationAfterClassModification
	|instVarName nRegisteredMethods|
	instVarName := 'foobar'. 
	self undoInTearDownDo: [self tracePackage: self tbPackage].
	
	nRegisteredMethods := (self tbMethods select: [:ea | ea isMwMethodWrapper]).
	[
		STbPerson addInstVarName: instVarName.
		self assert: (STbPerson methodDict values allSatisfy: [:ea | ea isMwMethodWrapper]).
		self assert: ((STbEmployee >> #nonInstVarAccessMethod) isMwMethodWrapper).
		self assert: ((STbEmployee >> #instVarAccessMethod) isMwMethodWrapper).
		self assert: nRegisteredMethods size equals: (self tbMethods select: [:ea | ea isMwMethodWrapper]) size]
	ensure: [
		(STbPerson instVarNames includes: instVarName)
				ifTrue: [STbPerson removeInstVarName: instVarName] ]! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 7/12/2010 20:26:07.837'!
testRewrapAfterChangeOfWrappedMethod
 
	self undoInTearDownDo: [
		self tracePackage: self tbPackage ].
	 
	STbPerson compile: (STbPerson sourceCodeAt: #firstname).
	self should: [(STbPerson >> #firstname) isMwMethodWrapper].! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 8/9/2010 17:56:27.417'!
testUninstall
	self instrumentor instrumentMethod: self exampleMethod.
	self instrumentor uninstrumentMethod: self exampleMethod.
	self deny: self exampleMethod isMwMethodWrapper.! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 8/9/2010 18:02:09.606'!
testUnregisterAllAndReset
	self instrumentor instrumentPackage: self tbPackage.
	self instrumentor uninstrumentAllAndReset.
	self assert: [self instrumentor instrumentedPackages size = 0].
	self assert: (self tbMethods allSatisfy: [:ea | ea isMwMethodWrapper not]).! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 7/12/2010 20:26:07.831'!
testUnregisterPackage
	| aPackage |
	aPackage := self tbPackage.
	self instrumentor instrumentPackage: aPackage.
	self should: [(STbPerson >> #firstname) isMwMethodWrapper].
	self instrumentor uninstrumentPackage: aPackage.
	self shouldnt: [(STbPerson >> #firstname) isMwMethodWrapper].! !

!SWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 8/20/2010 13:48:05.044'!
testWrapperInstallation
	| aPackage |
	aPackage := self tbPackage.
	
	self instrumentor instrumentPackage: aPackage.
	self should: [(STbPerson >> #firstname) isMwMethodWrapper].
	self shouldnt: [(STbPersonTest >> #testFirstnameAccessors) isMwMethodWrapper].
	
	self instrumentor uninstrumentPackage: aPackage.
	self shouldnt: [(STbPerson >> #firstname) isMwMethodWrapper].
	
	self instrumentor instrumentPackage: aPackage.
	self instrumentor instrumentPackage: aPackage.
	self instrumentor uninstrumentPackage: aPackage.
	self shouldnt: [(STbPerson >> #firstname) isMwMethodWrapper].! !

SEventHandler subclass: #SInstrumentor
	instanceVariableNames: 'classes packages methods beforeUninstallBlock createExtensionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing'!

!SInstrumentor class methodsFor: 'instance creation' stamp: 'bs 7/5/2010 10:31:27.156'!
pvtNewFrom: aClass
	^ self 
		pvtNewFrom: aClass 
		createExtensionBlock: [ :method | SMethodExtension new ]! !

!SInstrumentor class methodsFor: 'instance creation' stamp: 'bs 7/5/2010 10:23:05.196'!
pvtNewFrom: aClass createExtensionBlock: aBlock
	^ aClass new
		createExtensionBlock: aBlock;
		yourself.! !

!SInstrumentor class methodsFor: 'instance creation' stamp: 'bs 7/5/2010 10:31:44.308'!
weaving
	^ self pvtNewFrom: SWeavingInstrumentor! !

!SInstrumentor class methodsFor: 'instance creation' stamp: 'bs 7/5/2010 10:41:39.975'!
weavingAndCreateExtensionsWith: aBlock
	^ self pvtNewFrom: SWeavingInstrumentor createExtensionBlock: aBlock.! !

!SInstrumentor class methodsFor: 'instance creation' stamp: 'bs 7/5/2010 10:31:54.024'!
wrapping
	^ self pvtNewFrom: SWrappingInstrumentor! !

!SInstrumentor class methodsFor: 'instance creation' stamp: 'bs 7/5/2010 10:41:13.592'!
wrappingAndCreateExtensionsWith: aBlock
	^ self pvtNewFrom: SWrappingInstrumentor createExtensionBlock: aBlock.! !

!SInstrumentor methodsFor: 'accessing' stamp: 'bs 7/1/2010 11:22:11.213'!
beforeUninstallBlock
	"^ beforeUninstallBlock"
	^ [ :aMethod | aMethod resetAllCoverageData ]! !

!SInstrumentor methodsFor: 'accessing' stamp: 'bs 7/1/2010 11:18:08.951'!
beforeUninstallBlock: aBlock
	beforeUninstallBlock := aBlock! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 7/3/2010 14:40:10.542'!
canInstrument: aMethod
	^ self canInstrument: aMethod selector inClass: aMethod methodClass! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 16:02:30.423'!
canInstrument: selector inClass: aClass
	| predicateToAsk subject |
	predicateToAsk := aClass isMeta 
		ifTrue: [ #mayClassMethodBeInstrumented: ] 
		ifFalse: [ #mayMethodBeInstrumented: ].
		
	subject := aClass isMeta ifTrue: [ aClass theNonMetaClass ] ifFalse: [ aClass ].
		
	^ (subject respondsTo: predicateToAsk) 
		ifTrue: [ subject perform: predicateToAsk with: selector ]
		ifFalse: [ true ]! !

!SInstrumentor methodsFor: 'initialize-release' stamp: 'bs 1/4/2010 11:53'!
cleanUp
	self uninstrumentAllAndReset.! !

!SInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/5/2010 09:56:23.675'!
createExtensionBlock
	^ createExtensionBlock! !

!SInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/5/2010 09:56:35.112'!
createExtensionBlock: aBlock
	createExtensionBlock := aBlock! !

!SInstrumentor methodsFor: 'initialize-release' stamp: 'bs 1/4/2010 11:53'!
finalize
	self cleanUp! !

!SInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/5/2010 09:54:43.51'!
installExtension: uninstrumentedMethod
	| extension |
	extension := self createExtensionBlock value: uninstrumentedMethod.
	extension clientMethod: uninstrumentedMethod.
	uninstrumentedMethod methodExtension: extension.! !

!SInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/5/2010 09:46:43.038'!
installInstrumentation: aMethod
	self installExtension: aMethod
	! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 8/9/2010 17:09:03.734'!
instrumentClass: aClass
	|metaClass|
	metaClass := aClass class.
	{aClass. metaClass} do: [:c |
		c methodsDo: [ :method | self instrumentMethod: method ]].! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 8/9/2010 17:46:46.386'!
instrumentMethod: aMethod
	aMethod isTestMethod
		ifTrue: [ self installExtension: aMethod ]
		ifFalse: [
			(self canInstrument: aMethod)
				ifTrue: [
					self installInstrumentation: aMethod ] ]! !

!SInstrumentor methodsFor: 'public' stamp: 'bs 8/9/2010 17:53:51.819'!
instrumentPackage: aPackage
	(self instrumentedPackages includes: aPackage) 
		ifFalse: [
			self instrumentedPackages add: aPackage.
			aPackage classes do: [:aClass | self instrumentClass: aClass ].
			^ true ].
	^ false.! !

!SInstrumentor methodsFor: 'public' stamp: 'bs 10/28/2009 14:09'!
instrumentedPackages
	"packages := nil"
	^ packages ifNil: [packages := WeakSet new]! !

!SInstrumentor methodsFor: 'querying' stamp: 'bs 8/9/2010 16:45:03.367'!
packageOfClass: aClass
	^ PackageOrganizer default
		packageOfClass: aClass
		ifNone: [PackageInfo named: (Smalltalk organization categoryOfElement: aClass name)]! !

!SInstrumentor methodsFor: 'event handling' stamp: 'bs 8/10/2010 15:41:10.955'!
postprocess: aSightEvent
	aSightEvent removedMethods do: [:ea | self uninstrumentMethod: ea].
	! !

!SInstrumentor methodsFor: 'event handling' stamp: 'bs 8/10/2010 15:41:06.942'!
preprocess: aSightEvent
	aSightEvent addedMethods do: [:ea | self instrumentMethod: ea].
	
	! !

!SInstrumentor methodsFor: 'event handling' stamp: 'bs 8/10/2010 15:41:01.334'!
process: aSightEvent
	! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 8/9/2010 22:41:26.775'!
reinstrumentMethod: item oldMethod: oldItem
	self instrumentMethod: item.
	self uninstrumentMethod: oldItem.! !

!SInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/5/2010 09:46:22.404'!
uninstallExtension: uninstrumentedMethod
	uninstrumentedMethod resetMethodExtension.! !

!SInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 3/2/2010 23:07:08.158'!
uninstallInstrumentation: aCompiledMethod
	self subclassResponsibility! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 8/9/2010 17:48:25.32'!
uninstrumentAllAndReset
	self instrumentedPackages do: [:ea | self uninstrumentPackage: ea].! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 8/9/2010 17:08:50.838'!
uninstrumentClass: aClass
	| metaClass |
	metaClass := aClass class.
	{aClass. metaClass} do: [:c |
		c methodDict values do: [:method | self uninstrumentMethod: method ]].! !

!SInstrumentor methodsFor: 'instrumenting' stamp: 'bs 8/9/2010 17:56:09.277'!
uninstrumentMethod: aMethod
	aMethod isTestMethod
		ifTrue: [self uninstallExtension: aMethod]
		ifFalse: [self uninstallInstrumentation: aMethod]! !

!SInstrumentor methodsFor: 'public' stamp: 'bs 3/2/2010 22:40:41.239'!
uninstrumentPackage: aPackage
	(self instrumentedPackages includes: aPackage) 
		ifTrue: [
			aPackage classes do: [:aClass | self uninstrumentClass: aClass].
			self instrumentedPackages remove: aPackage ]! !

SInstrumentor subclass: #SWeavingInstrumentor
	instanceVariableNames: 'messageToSend'
	classVariableNames: 'ExtensionIndices'
	poolDictionaries: ''
	category: 'Sight-Tracing-Weaving'!

!SWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'bs 7/2/2010 17:25:40.585'!
extensionAtIndex: anIndex
	^ self orderedExtensions at: anIndex! !

!SWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'bs 7/2/2010 17:25:01.597'!
indexForExtension: anObject
	(self orderedExtensions includes: anObject)
		ifFalse: [ self orderedExtensions add: anObject ].
	^ self orderedExtensions indexOf: anObject.! !

!SWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'bs 7/2/2010 17:24:05.113'!
orderedExtensions
	^ ExtensionIndices ifNil: [ ExtensionIndices := IndexedIdentityCollection new ]! !

!SWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'bs 7/2/2010 17:24:41.269'!
removeIndexForExtension: anObject
	self orderedExtensions remove: anObject ifAbsent: []! !

!SWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'bs 7/2/2010 17:22:54.052'!
resetExtensionIndex
	ExtensionIndices := nil! !

!SWeavingInstrumentor methodsFor: 'accessing' stamp: 'bs 7/1/2010 15:39:29.997'!
beforeUninstallBlock
	"^ beforeUninstallBlock"
	^ [ :aMethod | 
			aMethod resetAllCoverageData ]! !

!SWeavingInstrumentor methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 15:34:47.724'!
canInstrument: selector inClass: aClass
	
	(self canInstrumentClass: aClass) ifFalse: [ ^ false ].
	^ super canInstrument: selector inClass: aClass! !

!SWeavingInstrumentor methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 15:28:40.97'!
canInstrumentClass: aClass
	| classesNotToBeInstrumented |
	classesNotToBeInstrumented := { SInstrumentor. SInstrumentor class. SWrappingInstrumentor. SWrappingInstrumentor class. SWeavingInstrumentor. SWeavingInstrumentor class.}.
	
	^ (classesNotToBeInstrumented includes: aClass) not! !

!SWeavingInstrumentor methodsFor: 'generation' stamp: 'bs 7/4/2010 20:24:51.935'!
createTraceCallFor: aCompiledMethod
	| extIndex traceCallString tmpMethodNode |
	extIndex := SWeavingInstrumentor indexForExtension: aCompiledMethod methodExtension.
	
	traceCallString := 
		'(' , SWeavingInstrumentor asString , ' extensionAtIndex: ' , extIndex asString , ')' ,
		'     ', self messageToSend, ' self'.

	tmpMethodNode := Parser new parse: 'foo ' , traceCallString class: Object.
	^ tmpMethodNode body statements first! !

!SWeavingInstrumentor methodsFor: 'generation' stamp: 'bs 3/5/2010 09:31:06.12'!
generateTracingAdaptationOf: aCompiledMethod
	| methodNode traceCallNode instrumentedMethod |
	
	methodNode := self parseSource: aCompiledMethod.
	
	traceCallNode := self createTraceCallFor: aCompiledMethod.
	methodNode body statements addFirst: traceCallNode.
	
	instrumentedMethod := methodNode generate. 
	instrumentedMethod uninstrumentedMethod: aCompiledMethod.
		
	^ instrumentedMethod! !

!SWeavingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/3/2010 14:13:49.757'!
installInstrumentation: aMethod
	| adaptation | 
	super installInstrumentation: aMethod.
	adaptation := self generateTracingAdaptationOf: aMethod.
	adaptation methodExtension: aMethod methodExtension.
	adaptation installSilently.! !

!SWeavingInstrumentor methodsFor: 'accessing' stamp: 'bs 7/5/2010 10:27:22.659'!
messageToSend
	^ #beforeMethodWithReceiver:! !

!SWeavingInstrumentor methodsFor: 'generation' stamp: 'bs 3/5/2010 09:32:21.454'!
parseSource: aCompiledMethod
	| source |
	source := aCompiledMethod getSource.
	^ Parser new parse: source class: aCompiledMethod methodClass.
	! !

!SWeavingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/5/2010 09:47:37.902'!
uninstallInstrumentation: aCompiledMethod
	| uninstrumentedMethod |
	aCompiledMethod isInstrumentedMethod
		ifTrue: [
			uninstrumentedMethod := aCompiledMethod uninstrumentedMethod.
			SWeavingInstrumentor removeIndexForExtension: uninstrumentedMethod methodExtension.
			aCompiledMethod isInstalled 
				ifTrue: [ "could have been deleted" 
					uninstrumentedMethod installSilently.
					self uninstallExtension: uninstrumentedMethod ] ].! !

SInstrumentor subclass: #SWrappingInstrumentor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Tracing-Wrapping'!

!SWrappingInstrumentor methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 16:05:10.968'!
canInstrument: selector inClass: aClass
	^ (self wrapperClass canWrap: selector inClass: aClass)
		and: [ self canWrapClass: aClass ]
		and: [ super canInstrument: selector inClass: aClass ]! !

!SWrappingInstrumentor methodsFor: 'instrumenting' stamp: 'bs 7/20/2010 16:04:48.556'!
canWrapClass: aClass
	| classesNotToBeWrapped |
	classesNotToBeWrapped := {SInstrumentor. SInstrumentor class. SWrappingInstrumentor. SWrappingInstrumentor class. SWeavingInstrumentor. SWeavingInstrumentor class.}.
	
	^ (classesNotToBeWrapped includes: aClass) not.! !

!SWrappingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/3/2010 14:14:14.248'!
installInstrumentation: aMethod
	| wrapper |
	super installInstrumentation: aMethod.
	SystemChangeNotifier uniqueInstance doSilently: [
		wrapper := self wrapperClass on: aMethod selector inClass: aMethod methodClass.
		wrapper install ]! !

!SWrappingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 7/5/2010 09:50:01.304'!
uninstallInstrumentation: aCompiledMethod
	aCompiledMethod isMwMethodWrapper 
		ifTrue: [	
			aCompiledMethod isInstalled 
				ifTrue: [ 
					self uninstallExtension: aCompiledMethod unwrappedMethod.
					aCompiledMethod uninstall. ] ].! !

!SWrappingInstrumentor methodsFor: 'accessing' stamp: 'bs 7/4/2010 12:47:10.753'!
wrapperClass
	^ STracingWrapper! !

!AbstractEvent methodsFor: '*Sight-Tracing' stamp: 'bs 7/4/2010 13:59:49.5'!
sEventHandlerSelector
	^ (self itemKind, self changeKind, ':') asSymbol.! !
STracingWrapper initialize!
